local LibStub = LibStub
local Geodew = LibStub("AceAddon-3.0"):GetAddon("Geodew")
local Geodew_UI = Geodew.UI

local grid_direction = {}
grid_direction.__index = grid_direction
setmetatable(grid_direction,Geodew_UI.grid)

function Geodew_UI:CreateGridDirection(db)
	local o = Geodew_UI:CreateGrid(db)
	local frame = o.frame
	local direction = frame:CreateTexture(nil, "OVERLAY") 
	direction:Hide()
	direction:SetTexture("Interface\\AddOns\\Geodew\\texture\\Arrow.blp") 
	direction:SetBlendMode("ADD")
	direction:SetPoint("CENTER")
	direction:SetAllPoints(frame)
	o.direction = direction
	setmetatable(o,grid_direction)
	return o
end

local math_floor = math.floor
local pi2 = math.pi * 2
local math_atan2 = math.atan2
local GetPlayerFacing = GetPlayerFacing


function grid_direction:HideDirection()
	self.direction:Hide()
	self.background:Show()
end

function grid_direction:Shift(dx,dy)
	if dx == 0 and dy == 0 then
		self:HideDirection()
		return
	end
	local cell = math_floor((math_atan2(dy,dx)-GetPlayerFacing()) / pi2 * 108 + 0.5) % 108
	local column = cell % 9
	local row = math_floor(cell / 9)
	local xStart = (column * 56) / 512
	local yStart = (row * 42) / 512
	local xEnd = ((column + 1) * 56) / 512
	local yEnd = ((row + 1) * 42) / 512
	local direction = self.direction
	direction:SetTexCoord((column * 56) / 512, xEnd, yStart, yEnd)
	self.background:Hide()
	direction:Show()
end
