local LibStub = LibStub
local AceAddon = LibStub("AceAddon-3.0")
local Geodew_Options = AceAddon:GetAddon("Geodew_Options")
local Geodew_Options_UI = Geodew_Options.UI
local Geodew_Options_Module = Geodew_Options.Module
local L = LibStub("AceLocale-3.0"):GetLocale("Geodew_Options")

function Geodew_Options_Module:CreateRaidCDOptions()
	local options = 
	{
		Bar = Geodew_Options_UI:CreateBarOptions(),
		Grid = Geodew_Options_UI:CreateGridOptions(),
		enable =
		{
			name = L["Enable"],
			type = "toggle",
			set = function(info,val)
				local addon = AceAddon:GetAddon(info[1])
				addon.db.profile.enable = val
				addon:PLAYER_SPECIALIZATION_CHANGED()
			end,
			get = function(info)
				local addon = AceAddon:GetAddon(info[1])
				return addon.db.profile.enable
			end,
			width = "full",
		},
		timer = 
		{
			name = L["Timer"],
			type = "range",
			min = 0,
			max = 5,
			step = 0.01,
			set = function(info,val)
				local addon = AceAddon:GetAddon(info[1])
				addon.db.profile.timer = val
				addon:PLAYER_SPECIALIZATION_CHANGED()
			end,
			get = function(info)
				local addon = AceAddon:GetAddon(info[1])
				return addon.db.profile.timer
			end,
		},
		raid_cd_prepare_time = 
		{
			name = L["Prepare Time"],
			type = "range",
			min = 0,
			max = 180,
			set = function(info,val)
				local addon = AceAddon:GetAddon(info[1])
				addon.db.profile.raid_cd_prepare_time = val
			end,
			get = function(info)
				local addon = AceAddon:GetAddon(info[1])
				return addon.db.profile.raid_cd_prepare_time
			end,
		},
	}
	return options
end