if select(2,UnitClass("player")) ~= "MONK" then return end

local LibStub = LibStub
local AceAddon = LibStub("AceAddon-3.0")

local Geodew = AceAddon:GetAddon("Geodew")

local AceDB = LibStub("AceDB-3.0")
local Geodew_Transcendence = AceAddon:NewAddon("Geodew_Transcendence", "AceEvent-3.0","AceTimer-3.0")
local grid
local SpellID = 119996

function Geodew_Transcendence:OnInitialize()
	self.db = AceDB:New("Geodew_TranscendenceDB",Geodew.Module.hot())
	self.grid=Geodew.UI:CreateGridDirection(self.db)
	grid = self.grid
	self.db.RegisterCallback(self, "OnProfileChanged", "OnEnable")
	self.db.RegisterCallback(self, "OnProfileCopied", "OnEnable")
	self.db.RegisterCallback(self, "OnProfileReset", "OnEnable")
end

function Geodew_Transcendence:OnEnable()
	grid:Update()
	self:PLAYER_SPECIALIZATION_CHANGED()
end

local spell_name = GetSpellInfo(SpellID)
local transcendence_spell_id = 101643
local transcendence = GetSpellInfo(transcendence_spell_id)
local x,y,fl,mp
local sx,sy,sfl,smp
local UnitPosition = UnitPosition
local IsUsableSpell = IsUsableSpell
local line_id
local string_format = string.format
local math_sqrt = math.sqrt

function Geodew_Transcendence:UNIT_SPELLCAST_SUCCEEDED(...)
	if select(2,...)=="player" then
		local spellId = select(6,...)
		if spellId== transcendence_spell_id then
			x,y,fl,mp = UnitPosition("player")
		elseif spellId == SpellID then
			if select(4,...) == line_id then
				x,y,fl,mp=sx,sy,sfl,smp
			else
				x,y,fl,mp=UnitPosition("player")
			end
			line_id = nil
			sx,sy,sfl,smp = nil,nil,nil,nil
		end
	end
end

function Geodew_Transcendence:UNIT_SPELLCAST_SENT(...)
	local _,unit,spell,lid = ...
	if unit=="player" then
		if spell== spell_name then
			line_id = lid
			sx,sy,sfl,smp = UnitPosition("player")
		end
	end
end


function Geodew_Transcendence:TimerFeedback()
	local name, rank, icon, count, dispelType, duration, expires = UnitAura("PLAYER",transcendence,nil, "player")
	if name == nil then
		grid.center_text:Hide()
		grid:HideDirection()
		return
	end
	grid:SetCD(SpellID)

	local px,py,pfl,pmp = UnitPosition("player")
	if pfl == fl and pmp == mp then
		local dx = x-px
		local dy = y-py
		grid:Shift(x-px,y-py)
		local ds= dx*dx+dy*dy
		if IsUsableSpell(SpellID)==true then
			grid:SetLow()
		elseif ds<1600 then
			grid:SetMid()
		else
			grid:SetHigh()
		end
		local center_text = grid.center_text
		center_text:SetText(string_format("%.0f",math_sqrt(ds)))
		center_text:Show()
	end
end

function Geodew_Transcendence:PLAYER_SPECIALIZATION_CHANGED()
	local profile = self.db.profile
	if profile.enable == true then
		if self.timer then
			self:CancelTimer(self.timer)
		end
		self.timer = self:ScheduleRepeatingTimer("TimerFeedback", self.db.profile.timer)
		self:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		self:RegisterEvent("UNIT_SPELLCAST_SENT")
		grid:Show()
	else
		if self.timer then
			self:CancelTimer(self.timer)
			self.timer = nil
		end
		self:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED")
		self:UnregisterEvent("UNIT_SPELLCAST_SENT")
		grid:Hide()
	end
end

